<script lang="ts">
import Vue from 'vue';
import { ImageUrlMixin } from '~/mixins';

export default Vue.extend({
  mixins: [ImageUrlMixin],
  props: {
    header: {
      type: String,
      required: true,
      default: '',
    },
    subheader: {
      type: String,
      required: true,
      default: '',
    },
    assets: {
      type: Array,
      required: true,
      default: () => [],
    },
    text: {
      type: String,
      required: true,
      default: '',
    },
    secondaryColumnText: {
      type: String,
      required: false,
      default: '',
    },
    location: {
      type: String,
      required: true,
      default: '',
    },
    agenda: {
      type: Array,
      required: true,
      default: () => [],
    },
    cta: {
      type: Object,
      required: false,
      default: () => {},
    },
    registrationClosed: {
      type: Boolean,
      required: false,
      default: false,
    },
  },
  data() {
    return {
      openItem: -1,
    };
  },
  methods: {
    toggleItem(index: number) {
      if (index === this.openItem) {
        this.openItem = -1;
      } else {
        this.openItem = index;
      }
    },
  },
});
</script>

<template>
  <SlpContainer>
    <div
      id="agenda"
      class="agenda-header"
      :class="{ 'agenda-header--includes-blurb': text }"
    >
      <div
        class="agenda__row"
        :class="{ 'agenda__row-grid': secondaryColumnText }"
      >
        <SlpTypography variant="heading2-bold" tag="h2" class="header">
          {{ header }}
        </SlpTypography>
        <div v-if="assets" class="agenda-header-image">
          <img
            v-for="asset in assets"
            :key="asset.alt"
            :src="asset?.src"
            :alt="asset?.alt"
            loading="lazy"
          />
        </div>
        <div v-if="text" class="agenda-blurb">
          <SlpTypography variant="body2" tag="div"
            ><div v-html="$md.render(text)"
          /></SlpTypography>
        </div>

        <div v-html="$md.render(secondaryColumnText)" />
      </div>
    </div>

    <div class="agenda-container">
      <div class="agenda-cta">
        <SlpTypography variant="body2">{{ subheader }}</SlpTypography>
        <SlpButton
          v-if="!registrationClosed && cta"
          :href="cta?.externalUrl"
          variant="secondary"
          :data-ga-name="cta.dataGaName"
          :data-ga-location="cta.dataGaLocation"
        >
          {{ cta?.text }}
          <SlpIcon
            :variant="cta?.iconVariant || 'product'"
            :name="cta?.iconName || 'arrow-down'"
            class="slp-ml-8"
        /></SlpButton>
      </div>
      <div
        v-for="(item, index) in agenda"
        :key="item.name + index"
        class="agenda-event"
        :class="{
          open: index === openItem && item.description,
          'agenda-event__accordion': item.description,
        }"
        @click="toggleItem(index)"
      >
        <div
          class="information"
          :class="{ 'information--w-speakers': item.speakers }"
        >
          <div class="time-wrapper">
            <SlpTypography variant="body1-bold" class="time" tag="div"
              ><div v-html="$md.render(item.time)"></div
            ></SlpTypography>
            <SlpIcon
              variant="product"
              :name="index === openItem && item.description ? 'dash' : 'plus'"
              class="plus-icon mobile"
            />
          </div>
          <SlpTypography variant="body1-bold" class="name">
            {{ item.name }}
            <span v-if="item.logo?.src" class="logo">
              <nuxt-img
                :src="item.logo?.src"
                :alt="item.logo?.alt"
                loading="lazy"
                format="webp"
                quality="99"
              />
            </span>
          </SlpTypography>
          <div
            v-if="openItem === index && item.description"
            class="description"
            :class="{ 'description--w-blurb': item.description?.blurb }"
          >
            <SlpTypography variant="heading5-bold">
              {{ item.name }}
            </SlpTypography>

            <div
              variant="body1"
              class="body1"
              v-html="$md.render(item.description)"
            ></div>
          </div>
          <div
            v-for="speaker in item.speakers"
            :key="speaker.name"
            class="speaker"
          >
            <div class="info-container">
              <img
                v-if="speaker"
                loading="lazy"
                :style="{ 'object-position': speaker.image?.position || 'top' }"
                :src="
                  parseImageUrl(speaker.image?.src, 440, 480) ||
                  '/nuxt-images/events/world-tour/speakers/Speaker-Placeholder.jpg'
                "
                :alt="`${speaker.name} Photo`"
                :class="speaker.class"
              />

              <div class="speaker-info">
                <SlpTypography variant="body1-bold">{{
                  speaker.name
                }}</SlpTypography>
                <SlpTypography variant="body3" class="title">{{
                  speaker.title
                }}</SlpTypography>
                <SlpTypography variant="body2-bold">{{
                  speaker.company
                }}</SlpTypography>
                <SlpTypography
                  v-if="speaker.note"
                  variant="body3"
                  class="italic"
                >
                  {{ speaker.note }}
                </SlpTypography>
              </div>
            </div>
            <div
              v-if="openItem === index && item.description"
              class="biography"
            >
              <SlpTypography
                v-if="speaker.biography || speaker.name"
                variant="body3-bold"
                >Biography</SlpTypography
              >
              <SlpTypography variant="heading5-bold">{{
                speaker?.name
              }}</SlpTypography>
              <div class="body1" v-html="$md.render(speaker.biography)"></div>
            </div>
          </div>

          <SlpIcon
            v-if="item.description"
            variant="product"
            :name="index === openItem && item.description ? 'dash' : 'plus'"
            class="plus-icon"
          />
        </div>
        <div class="details"></div>
      </div>
    </div>
  </SlpContainer>
</template>

<style lang="scss" scoped>
.agenda {
  &-container {
    background: #2f2a6b;
    border-radius: 8px;
    color: white;
    padding: 0 0 44px 0;
  }
  &-cta {
    display: flex;
    flex-direction: row;
    justify-content: space-between;
    flex-wrap: wrap;
    background: #2f2a6b;
    gap: 16px;
    align-items: center;
    border-radius: 8px 8px 0 0;
    padding: 16px 24px;
    position: sticky;
    top: 84px;
    box-shadow: 0px 0px 10px #2d1231;
    @media (max-width: $breakpoint-md) {
      top: 116px;
    }
  }
  &-event {
    cursor: default;
    transition: all 0.3s;
    &:nth-child(odd) {
      background-color: #3a3481;
    }
    &:last-child {
      border-radius: 0 0 8px 8px;
    }
    &:not(.agenda-event__accordion) {
      :deep {
        .plus-icon.mobile {
          display: none !important;
        }
      }
    }
    &__accordion {
      cursor: pointer;
    }
    &.open {
      // background: $color-surface-100;
      // color: $color-text-300;
      .information {
        grid-template-rows: 80px auto;
        @media (max-width: $breakpoint-md) {
          grid-template-rows: 20px auto;
        }
      }
    }
    .information {
      padding: 24px 24px 0 24px;
      display: grid;
      grid-template-columns: 150px repeat(4, 1fr) 20px;
      gap: 16px 0;
      @media (max-width: $breakpoint-md) {
        grid-template-columns: 1fr;
        margin-right: 0;
        gap: 16px;
      }
      .time-wrapper {
        display: flex;
        justify-content: space-between;
      }
      .time {
        max-width: 100px;
      }
      .plus-icon {
        display: none;
        grid-column-start: 6;
        grid-row: 1;
        justify-self: end;
        @media (min-width: $breakpoint-md) {
          display: initial;
        }
        &.mobile {
          display: block;
          @media (min-width: $breakpoint-md) {
            display: none;
          }
        }
      }
      .name {
        span:deep(p) {
          margin-bottom: 8px;
        }
        @media (min-width: $breakpoint-md) {
          grid-column-start: 2;
          grid-column-end: 4;
        }
      }

      .speakers {
        display: flex;
        flex-direction: column;
        gap: 16px;
      }
      .speaker {
        display: flex;
        flex-direction: column;
        gap: 16px;
        @media (min-width: $breakpoint-md) {
          grid-column: 4 / span 2;
          grid-row: span 2;
        }
        .info-container {
          display: flex;

          img {
            margin-right: 32px;
            width: 180px;
            height: 150px;
            border-radius: 4px 4px 60px 4px;
            object-fit: cover;
            object-position: top;
            min-width: 180px;
            &.contain {
              object-fit: contain;
            }

            @media (max-width: $breakpoint-md) {
              border-radius: 4px 4px 30px 4px;
              max-width: 90px;
              min-width: 90px;
              max-height: 74px;
              margin-right: 16px;
            }
          }
          .speaker-info {
            display: flex;
            flex-direction: column;
            gap: 8px;
            .italic {
              font-style: italic;
            }
          }
        }
      }
    }
    .details {
      display: grid;
      padding: 24px;
      grid-template-columns: 1fr 1fr;
      @media (max-width: $breakpoint-md) {
        grid-template-columns: 1fr;
        gap: 32px;
      }
      gap: 64px;
    }
  }
  &-header {
    display: flex;
    margin-bottom: 64px;
    align-items: center;
    &--includes-blurb {
      flex-wrap: wrap;
    }
  }
  &-header-image {
    line-height: 0;
    margin-left: 16px;
  }
  &-blurb {
    margin-top: 24px;

    &:deep {
      p {
        margin-bottom: 16px;
      }

      strong {
        font-weight: $font-weight-bold;
      }

      ul,
      ol {
        padding-left: 1.25em;
      }
      li {
        margin-bottom: 16px;
      }

      ul {
        list-style-type: disc;
      }

      ol {
        list-style-type: auto;
      }
    }
  }
  &__row {
    &.agenda__row-grid {
      > div {
        break-inside: avoid-column;
      }
      @media (min-width: $breakpoint-md) {
        column-count: 2;
        gap: 130px;
      }
    }
    &:deep(ul) {
      padding-left: 32px;
      margin: 16px 0;

      li {
        margin-top: 8px;
        position: relative;

        &:before {
          content: url('/nuxt-images/icons/list-check-dark.svg');
          position: absolute;
          top: 3px;
          left: -30px;
        }
      }
    }
  }
}
.description {
  &:deep {
    p,
    ol,
    ul {
      margin-bottom: 16px;
    }

    li {
      margin-bottom: 8px;
    }

    strong {
      font-weight: $font-weight-bold;
    }

    ul {
      list-style-type: disc;
      padding-left: 1.25em;
    }
  }
  .title {
    @media (max-width: $breakpoint-md) {
      display: none;
    }
  }
  @media (min-width: $breakpoint-md) {
    grid-row: 2;
    grid-column: span 3;
    padding-right: 32px;
  }
  &--w-blurb {
    @media (min-width: $breakpoint-md) {
      grid-row: span 2;
    }
  }
}
.description,
.biography {
  display: flex;
  flex-direction: column;
  gap: 16px;
}
.header {
  position: relative;
  // &::before {
  //   content: url('/nuxt-images/events/world-tour/agenda-decoration.png');
  //   position: absolute;
  //   top: -100%;
  //   left: -4%;
  // }
}
</style>
